<?php
	/*
	 * Module:	bta_funcs.php
	 * Description: Helper functions and variables used throughout
	 * 		the Administration interface.
	 *
	 * Author:	danomac
	 * Written:	14-February-2004
	 *
	 * Copyright (C) 2004 danomac
	 *
	 * This program is free software; you can redistribute it and/or modify
	 * it under the terms of the GNU General Public License as published by
	 * the Free Software Foundation; either version 2 of the License, or
	 * (at your option) any later version.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU General Public License for more details.
	 *
	 * You should have received a copy of the GNU General Public License
	 * along with this program; if not, write to the Free Software
	 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	 */

	/* 
	 * Variables used in most of the admin pages.
	 */
	$adm_pageerr_title = $phpbttracker_id . " " . $phpbttracker_ver." Administration Error";
	$adm_page_title = $phpbttracker_id . " " . $phpbttracker_ver . " Administration";

	/*
	 * Action constants used in the forms
	 */
	define("ACTION_DELETE", 1);
	define("ACTION_RETIRE", 2);
	define("ACTION_UNHIDE", 3);
	define("ACTION_REVIVE", 4);
	define("ACTION_RDELETE", 5);
	define("ACTION_PBAN", 6);
	define("ACTION_PDELETE", 7);
	define("ACTION_UDELETE", 8);

	/*
	 * Called if mysql gives an error.
	 */
	function sqlErr($err) {
		echo "</TABLE></TD></TR></TABLE></TD></TR></TABLE><FONT COLOR='red' SIZE='+2'>mysql reported this error: $err</FONT></BODY></HTML>";
		exit;
	}

	/*
	 * My take on sorting an multidimensional array by a specified key
	 *
	 * Added: 24May04
	 */
	function array_sort($array, $sortkey) {

		/*
		 * Counter to keep track of elements to sort
		 */
	   $i=0;

		/*
		 * Traverse through array getting the values needed
		 * to sort
		 */
		foreach ($array as $key => $value) {
      	$sortlist[$i] = $array[$key][$sortkey];
			$i++;
   	} 

		/*
		 * Now that we have all of the elements, sort the elements,
		 * then reset the array pointer
		 */
	   asort ($sortlist);
	   reset ($sortlist);

		/*
		 * Okay, now go through the sorted elements, and assign
		 * them in order in a new array
		 */
		foreach ($sortlist as $key => $value) {
   	      $sorted_array[] = $array[$key];
	   }
   	return $sorted_array;
	}

	/*
	 * Resets the SESSION array and destroys it.
	 *
	 * Added: 14-February-2004
	 */
	function admKillSession() {
		$_SESSION = array();
		session_destroy();
	}

	/*
	 * Spits out some formatted HTML with an error message and description.
	 * This also destroys the current session as a safety precaution.
	 *
	 * Added: 14-February-2004
	 */
	function admShowError($errmsg, $errdetail, $errpgtitle) {
		echo "<HTML>\r\n<HEAD>\r\n<TITLE>" . $errpgtitle . "</TITLE>\r\n";
		echo "<META NAME=\"Author\" CONTENT=\"danomac\">\r\n";
		echo "<LINK REL=\"stylesheet\" HREF=\"admin.css\" TYPE=\"text/css\" TITLE=\"Default\">\r\n</HEAD>\r\n\r\n";
		echo "<BODY CLASS=\"adm_error\">\r\n<P CLASS=\"adm_error\">".$errmsg."</P>\r\n";
		echo $errdetail;
		echo "\r\n<BR><BR><CENTER>Session terminated. You will need to go to the <A HREF=\"index.php\">login screen</A> to try again.</CENTER>";
		echo "\r\n</BODY>\r\n</HTML>";
		admKillSession();
	}

	/*
	 * Checks to see if a user is logged in and that their IP matches
	 * the ip the session started with.
	 * 
	 * Returns TRUE if they are logged in; FALSE otherwise.
	 *
	 * Added: 14-February-2004
	 */
	function admIsLoggedIn($clientIP) {
		if (!isset($_SESSION['authenticated']))
			return false;
		if ($_SESSION['authenticated'] != true)
			return false;
		if ($_SESSION['clientIP'] != $clientIP)
			return false;
		return true;
	}

	/*
	 * This shows a message, and redirects to an URL if needed
	 *
	 * Added: 14-February-2004
	 */
	function admShowMsg($msg, $detail, $pgtitle, $redirect = false, $redirURL = "", $redirWaitTime = 0) {
		echo "<HTML>\r\n<HEAD>\r\n<TITLE>$pgtitle</TITLE>\r\n";
		echo "<META NAME=\"Author\" CONTENT=\"danomac\">\r\n";

		if ($redirect)
			echo "<META http-equiv=\"refresh\" content=\"$redirWaitTime;URL=$redirURL\">";

		echo "<LINK REL=\"stylesheet\" HREF=\"admin.css\" TYPE=\"text/css\" TITLE=\"Default\">\r\n</HEAD>\r\n\r\n";
		echo "<BODY>\r\n<P CLASS=\"adm_title\">$msg</P><CENTER>$detail</CENTER>";
		if ($redirect) {
			echo "<BR<BR><CENTER>If the browser doesn't automatically redirect <A HREF=\"$redirURL\">click here.</A></CENTER>\r\n</BODY>\r\n</HTML>";
			exit;
		}
	}

	/*
	 * PHP function used to check the MD5 hash sent by JavaScript.
	 *
	 * Added: 14-February-2004
	 */
	function hmac_md5($key, $data) {
		if (extension_loaded("mhash"))
			return bin2hex(mhash(MHASH_MD5, $data, $key));
	
		// RFC 2104 HMAC implementation for php. Hacked by Lance Rushing
		$b = 64; // byte length for md5
		if (strlen($key) > $b)
			$key = pack("H*", md5($key));
		$key = str_pad($key, $b, chr(0x00));
		$ipad = str_pad("", $b, chr(0x36));
		$opad = str_pad("", $b, chr(0x5c));
		$k_ipad = $key ^ $ipad ;
		$k_opad = $key ^ $opad;
	
		return md5($k_opad . pack("H*", md5($k_ipad . $data)));
	}

	/*
	 * Function to spit out the administrative function URLs, and login information
	 * All this does is spit out <TR> headings, it expects to be in a TABLE structure already.
	 *
	 * Added: 16Mar04
	 */
	function admShowURL_Login($ip) {
		echo "<TR>\r\n\t<TD CLASS=\"data\" ALIGN=\"center\" COLSPAN=15><BR><BR><HR><B>Administrative functions</B></TD>\r\n</TR>\r\n";

		echo "<TR>\r\n";

		if ($_SESSION["admin_perms"]["add"] || $_SESSION["admin_perms"]["root"])
			echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\"><A HREF=\"bta_add.php\">Add new torrent</A></TD>\r\n";
		else
			echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\">&nbsp;</TD>\r\n";

		if ($_SESSION["admin_perms"]["retiredmgmt"] || $_SESSION["admin_perms"]["root"])
			echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\"><A HREF=\"bta_retired.php\">View/revive/delete Retired torrents</A></TD>\r\n";
		else
			echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\">&nbsp;</TD>\r\n";

		echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\"><A HREF=\"bta_consistency.php\" TARGET=\"_blank\">Manual database consistency check</A></TD>\r\n</TR>\r\n";

		echo "<TR>\r\n";
		if ($_SESSION["admin_perms"]["ipban"] || $_SESSION["admin_perms"]["root"])
			echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\"><A HREF=\"bta_banlist.php\">IP Banning</A></TD>\r\n";
		else
			echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\">&nbsp;</TD>\r\n";

		if ($_SESSION["admin_perms"]["usermgmt"] || $_SESSION["admin_perms"]["root"])
			echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\"><A HREF=\"bta_usermgmt.php\">User management</A></TD>\r\n";
		else
			echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\">&nbsp;</TD>\r\n";

		echo "\t<TD CLASS=\"data\" WIDTH=\"25%\" ALIGN=\"center\"><A HREF=\"bta_logout.php\">Log off</A></TD>\r\n</TR>\r\n";
		echo "<TR>\r\n\t<TD CLASS=\"data\" ALIGN=\"center\" COLSPAN=15><HR><B>Login Information</B><BR><BR>\r\n";

		/*
		 * Display information on the client.
		 */
		echo "\t\tYou are logging in from IP <B>"; 
		echo $ip . "</B><BR>Using <B>" . $_SERVER['HTTP_USER_AGENT'] . "</B> as a web client.";
		echo "<BR><B><FONT SIZE=-1>This information has been logged.</FONT></B><HR>\r\n"; 

		echo "\t</TD>\r\n</TR>\r\n";
	}

	/*
	 * Function to check to see if a date is valid. Return TRUE if OK, FALSE otherwise.
	 *
	 * Added: 18Mar04
	 */
	function isDate($dateInput, $allowNullEmpty=false) {
		/*
		 * If null or empty strings are allowed, and it IS null or empty, return true
		 */
		if ($allowNullEmpty)
			if (is_null($dateInput) || strlen($dateInput) == 0)
				return true;

		if (strpos($dateInput, " ") !== false) {
			return false;
		}

		$dateArray = explode("-", $dateInput);
		if (count($dateArray) != 3)
			return false;
		if (!is_numeric($dateArray[0]) || !is_numeric($dateArray[1]) || !is_numeric($dateArray[2]))
			return false;
		return checkdate($dateArray[1], $dateArray[2], $dateArray[0]);
	}
?>
