<?php
	/*
	 * Module:	upgrade.php
	 * Description: This script upgrades an existing database for use.
	 *
	 * Author:	danomac
	 * Written:	15-Oct-2004
	 *
	 * Copyright (C) 2004 danomac
	 *
	 * This program is free software; you can redistribute it and/or modify
	 * it under the terms of the GNU General Public License as published by
	 * the Free Software Foundation; either version 2 of the License, or
	 * (at your option) any later version.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU General Public License for more details.
	 *
	 * You should have received a copy of the GNU General Public License
	 * along with this program; if not, write to the Free Software
	 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	 */

	define (NO_SEL, 0);
	define (PHPBTP16, 1);

	/*
	 * Pre-Upgrade functions. These ask questions to the user pertaining to specifics
	 * regarding upgrading to the new version, and can vary version to version.
	 */
	function pre_upgr_phpbttrkplus16() {
		echo "\tUpgrading from: PHPBTTracker+ 1.6<BR><BR>\r\n";
		echo "\tNow for a few version-specific questions/issues:<BR><BR>\r\n";

		echo "\t<B><U>Upgrading the IP Banning section</U></B><BR><BR>\r\n";
		echo "\tThis script needs to update the tables to a new format. This script will need to either make changes to the existing\r\n";
		echo "\tban records or remove them permanently to make the change.<BR><BR>\r\n";
		echo "\tWhat do you want the script to do?<BR>\r\n";
		echo "\t&nbsp;&nbsp;&nbsp;<INPUT TYPE=RADIO NAME=\"ban_q\" VALUE=1 CHECKED> Do the changes and attempt to update the table data<BR>\r\n";
		echo "\t&nbsp;&nbsp;&nbsp;<INPUT TYPE=RADIO NAME=\"ban_q\" VALUE=2> Remove the bans permanently and make the structure changes<BR><BR>\r\n";

		echo "\t<B><U>Upgrading the usernames and category names</U></B><BR><BR>\r\n";
		echo "\tThis script will change any spaces in usernames and category names to underscores (_).\r\n";
		echo "\t<B>You will have to notify your users and possibly update your scripts to reflect this change.</B><BR><BR>\r\n";

		echo "\t<B><U>Cleaning up some internal tracker tables</U></B><BR><BR>\r\n";
		echo "\tThe new administration scripts will keep the internal tracker tables clean; however there is a need for a one-time\r\n";
		echo "\tsweep through them to ensure they are clean (if you go through a lot of torrents on the tracker there are remnants of\r\n";
		echo "\tthem lying around.) <B>WARNING:</B> If this part of the script fails, your tracker could be left in an unusable state!</B><BR><BR>\r\n";
		echo "\tWhat do you want the script to do?<BR>\r\n";
		echo "\t&nbsp;&nbsp;&nbsp;<INPUT TYPE=RADIO NAME=\"timestamps_q\" VALUE=1 CHECKED> No, don't do clean up<BR>\r\n";
		echo "\t&nbsp;&nbsp;&nbsp;<INPUT TYPE=RADIO NAME=\"timestamps_q\" VALUE=2> Yes, do the clean up<BR><BR>\r\n";

		echo "\t<B><U>Database Username/Password/Database Name</U></B><BR><BR>\r\n";
		echo "\tEnter the database details below. Use the username and password you use to logon to the Administrative interface as root.<BR><BR>\r\n";

		echo "\tDatabase name: <INPUT TYPE=\"text\" NAME=\"db_name\"><BR>\r\n";
		echo "\tDatabase location: <INPUT TYPE=\"text\" NAME=\"db_loc\" VALUE=\"localhost\"><BR>\r\n";
		echo "\tUsername: <INPUT TYPE=\"text\" NAME=\"dbusername\"><BR>\r\n";
		echo "\tPassword: <INPUT TYPE=\"text\" NAME=\"dbpassword\"><BR>\r\n";

		echo "\t<INPUT TYPE=\"HIDDEN\" NAME=\"upgrade_from_query\" VALUE=". $_POST["old_version"] . ">\r\n";
		echo "\t<BR><BR><INPUT TYPE=\"SUBMIT\" NAME=\"step4\" VALUE=\"Next -&gt;\">\r\n";
	}

	/*
	 * Upgrade functions.
	 */
	function upgr_phpbttrkplus16() {
		if (!isset($_POST["db_name"]) || !isset($_POST["db_loc"]) || !isset($_POST["dbusername"])) {
			echo "\tUpgrade aborted; you didn't specify database details required.\r\n";
		} else {
			if (strlen($_POST["db_name"]) == 0 || strlen($_POST["db_loc"]) == 0 || strlen($_POST["dbusername"]) == 0 ) {
				echo "\tUpgrade aborted; you didn't specify database details required.\r\n";
			} else {
				$db_password = ( isset($_POST["dbpassword"]) ) ? $_POST["dbpassword"] : "" ;

				if (isset($_POST["ban_q"])) {
					if ($_POST["ban_q"] == 2) 
						$clearban = true; 
					else 
						$clearban = false;
				} else {
					$clearban = false;
				}

				if (isset($_POST["timestamps_q"])) {
					if ($_POST["timestamps_q"] == 2) 
						$timestamps = true; 
					else 
						$timestamps = false;
				} else {
					$timestamps = false;
				}
				
				/*
				 * Connect to the database
				 */
				@mysql_connect($_POST["db_loc"], $_POST["dbusername"], $db_password) or die("\tCan't connect to database: ".mysql_error()."<BR>\r\n"); 

				/*
				 * Connect to the desired database
				 */
				@mysql_select_db($_POST["db_name"]) or die("\tCan't open database ".$_POST["db_name"].": " . mysql_error() . "<BR>\r\n");

				echo "\tStarting upgrade process...<BR><BR>\r\n";

				/*
				 * Check to see if this is the right database...
				 */
				if (!@mysql_query("SELECT `username` FROM `adminusers`")) {
					echo "<FONT COLOR=RED><B>This does not appear to be PHPBTTracker+ 1.6 database; script aborted.</B></FONT><BR>";
				} else {
					/*
					 * Create the new torrents table
					 */
					echo "Creating new torrents table... ";
					if (!@mysql_query("CREATE TABLE `torrents` (`info_hash` VARCHAR (40) DEFAULT '0' NOT NULL, `name` VARCHAR (255) NOT NULL, `metadata` LONGBLOB NOT NULL, PRIMARY KEY(`info_hash`))")) {
						echo "<FONT COLOR=RED>FAILED</FONT><BR>";
					} else {
						echo "done!<BR>";
					}

					/*
					 * Do the 3 queries to update the adminusers table
					 */
					echo "Updating administration users table (1/3)... ";
					if (!@mysql_query("ALTER TABLE `adminusers` ADD `perm_mirror` ENUM('Y','N')  DEFAULT 'N' NOT NULL")) {
						echo "<FONT COLOR=RED>FAILED</FONT><BR>";
					} else {
						echo "done!<BR>";
					}

					echo "Updating administration users table (2/3)... ";
					if (!@mysql_query("ALTER TABLE `adminusers` ADD `enabled` ENUM('Y','N')  DEFAULT 'Y' NOT NULL AFTER `comment`")) {
						echo "<FONT COLOR=RED>FAILED</FONT><BR>";
					} else {
						echo "done!<BR>";
					}

					echo "Updating administration users table (3/3)... ";
					if (!@mysql_query("ALTER TABLE `adminusers` ADD `disable_reason` VARCHAR(255)  DEFAULT \"\" NOT NULL AFTER `enabled`")) {
						echo "<FONT COLOR=RED>FAILED</FONT><BR>";
					} else {
						echo "done!<BR>";
					}	

					if ($clearban) {
						echo "\tStarting IP Banning transition...<BR>\r\n";
						echo "\tClearing all bans... ";
						if (!@mysql_query("TRUNCATE TABLE `ipbans`")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}	

						echo "Updating IP banning table (1/7)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` ADD `iplong` INT(10)  DEFAULT 0 NOT NULL AFTER `ip`")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (2/7)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` DROP PRIMARY KEY")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (3/7)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` ADD `ban_id` BIGINT UNSIGNED NOT NULL FIRST")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (4/7)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` ADD PRIMARY KEY (ban_id)")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (5/7)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` CHANGE `ban_id` `ban_id` BIGINT(20)  UNSIGNED NOT NULL AUTO_INCREMENT")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (6/7)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` AUTO_INCREMENT = 1")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (7/7)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` ADD INDEX (`iplong`)")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}
					} else {
						echo "Updating IP banning table (1/8)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` ADD `iplong` INT(10)  DEFAULT 0 NOT NULL AFTER `ip`")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (2/8)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` DROP PRIMARY KEY")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (3/8)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` ADD `ban_id` BIGINT UNSIGNED NOT NULL FIRST")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						/*
						 * Have to reindex everything...
						 */
						echo "Updating IP banning table [reindexing] (4/8)... ";
						$recordset = @mysql_query("SELECT `ip` FROM `ipbans`");

						$counter = 1;

						if (!$recordset) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							if (mysql_num_rows($recordset) > 0) {
								while ($row = mysql_fetch_row($recordset)) {
									@mysql_query("UPDATE `ipbans` SET `ban_id` = $counter WHERE `ip`=\"$row[0]\"");
									$counter++;
								}
								$updated = $counter-1;
								echo "done - $updated records reindexed!<BR>";
							} else {
								echo "done - no bans found!<BR>";
							}
						}

						echo "Updating IP banning table (5/8)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` ADD PRIMARY KEY (ban_id)")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (6/8)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` CHANGE `ban_id` `ban_id` BIGINT(20)  UNSIGNED NOT NULL AUTO_INCREMENT")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (7/8)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` AUTO_INCREMENT = $counter")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}

						echo "Updating IP banning table (8/8)... ";
						if (!@mysql_query("ALTER TABLE `ipbans` ADD INDEX (`iplong`)")) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>";
						}
					}
	
					if ($timestamps) {
						echo "\tTimestamp cleanup starting...<BR>\r\n";

						echo "\tBuilding a list of active torrents... ";
						$rstActiveTorrents = @mysql_query("SELECT `info_hash` FROM namemap");
						if (!$rstActiveTorrents) {
							echo "<FONT COLOR=RED>FAILED</FONT><BR>";
						} else {
							echo "done!<BR>\r\n";

							if (mysql_num_rows($rstActiveTorrents) > 0) {
								while ($rowActiveTorrent = mysql_fetch_row($rstActiveTorrents)) {
									$arActiveTorrents[] = $rowActiveTorrent[0];
								}
	
								echo "\tStarting cleanup... ";
								$rstTimestamps = @mysql_query("SELECT DISTINCT `info_hash` FROM timestamps");
								if (!$rstTimestamps) {
									echo "Table shows no stale records; no changes to database were made.<BR>\r\n";
								} else {
									if (mysql_num_rows($rstTimestamps) > 0) {
										$purged = 0;

										while ($rowTimestamps = mysql_fetch_row($rstTimestamps)) {
											if (!in_array($rowTimestamps[0], $arActiveTorrents)) {
												$purged++;
												@mysql_query("DELETE FROM `timestamps` WHERE `info_hash`=\"$rowTimestamps[0]\"");
											}
										}

										echo "Cleanup finished; $purged stale torrent records were removed. Keep an eye on the statistics for the existing torrents. You may need to readd torrents that show oddball results, or run the database consistency check.<BR>\r\n";
									} else {
										echo "Table shows no stale records; no changes to database were made.<BR>\r\n";
									}
								}
							} else {
								echo "\tNo active torrents on tracker. Purging old information if it exists.<BR>\r\n";
								@mysql_query("TRUNCATE TABLE `timestamps`");
							}
						}
					} else {
						echo "\tSkipping internal tables cleanup, as requested...<BR>\r\n";
					}

					/*
					 * Ok, now see what category names are available, and make them valid
					 * 3 tables have this information, we'll have to do 1 at a time...
					 */
					echo "\t<BR>OK, examining adminusers table for category names that have spaces in them... \r\n";
					$rstAdminCategory = mysql_query("SELECT DISTINCT `category` from `adminusers`");
					if (!$rstAdminCategory) {
						/*
						 * No categories, skip.
						 */
						echo "skipping, there do not appear to be category names in the adminusers table...<BR>\r\n";
					} else {
						/*
						 * Some categories were found, let's take a look at them...
						 */
						$counter=0;
						while ($row = mysql_fetch_row($rstAdminCategory)) {
							list($category) = $row;
							if (strpos($category, " ") !== false) {
								/*
								 * Gah, a space was found... let's fix it!
								 */
								$newcategory = ereg_replace(" ","_", $category);
								@mysql_query("UPDATE `adminusers` SET `category`=\"$newcategory\" WHERE `category`=\"$category\"");
								echo "\r\n\t<BR><B>!</B> Renaming $category => $newcategory!";
								$counter++;
							}
						}
						echo "\r\n\t<BR>Finished adminusers table. $counter categories changed! <B><FONT COLOR=RED>You may need to edit your stats scripts to reflect this!!!</FONT></B><BR>\r\n";
					}

					echo "\t<BR>OK, examining retired torrents table for category names that have spaces in them... \r\n";
					$rstRetiredCategory = @mysql_query("SELECT DISTINCT `category` from `retired`");
					if (!$rstRetiredCategory) {
						/*
						 * No categories, skip.
						 */
						echo "skipping, there do not appear to be category names in the retired torrents table...<BR>\r\n";
					} else {
						/*
						 * Some categories were found, let's take a look at them...
						 */
						$counter=0;
						while ($row = mysql_fetch_row($rstRetiredCategory)) {
							list($category) = $row;
							if (strpos($category, " ") !== false) {
								/*
								 * Gah, a space was found... let's fix it!
								 */
								$newcategory = ereg_replace(" ","_", $category);
								@mysql_query("UPDATE `retired` SET `category`=\"$newcategory\" WHERE `category`=\"$category\"");
								echo "\r\n\t<BR><B>!</B> Renaming $category => $newcategory!";
								$counter++;
							}
						}
						echo "\r\n\t<BR>Finished retired torrents table. $counter categories changed! <B><FONT COLOR=RED>You may need to edit your stats scripts to reflect this!!!</FONT></B><BR>\r\n";
					}

					echo "\t<BR>OK, examining active torrents table for category names that have spaces in them... \r\n";
					$rstActiveCategory = @mysql_query("SELECT DISTINCT `category` from `namemap`");
					if (!$rstActiveCategory) {
						/*
						 * No categories, skip.
						 */
						echo "skipping, there do not appear to be category names in the retired torrents table...<BR>\r\n";
					} else {
						/*
						 * Some categories were found, let's take a look at them...
						 */
						$counter=0;
						while ($row = mysql_fetch_row($rstActiveCategory)) {
							list($category) = $row;
							if (strpos($category, " ") !== false) {
								/*
								 * Gah, a space was found... let's fix it!
								 */
								$newcategory = ereg_replace(" ","_", $category);
								@mysql_query("UPDATE `namemap` SET `category`=\"$newcategory\" WHERE `category`=\"$category\"");
								echo "\r\n\t<BR><B>!</B> Renaming $category => $newcategory!";
								$counter++;
							}
						}
						echo "\r\n\t<BR>Finished active torrents table. $counter categories changed! <B><FONT COLOR=RED>You may need to edit your stats scripts to reflect this!!!</FONT></B><BR>\r\n";
					}

					/*
					 * Upgrade should be done
					 */
					echo "\t<BR><BR><BR>Upgrade completed! If any part of the script failed, please try re-running this upgrade script.<BR><BR>\r\n";
					echo "\t<B>Delete install.php and/or upgrade.php from your web server if it was successful!</B> Refer to the INSTALL for the rest of the installation procedure.";
				}
			}
		}
	}

	if (isset($_POST["step4"])) {
		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<HTML>\r\n<HEAD>\r\n\t<META NAME=\"Author\" CONTENT=\"danomac\">\r\n";
		echo "\t<TITLE>PHPBTTracker+ Upgrade script</TITLE>\r\n</HEAD>\r\n<BODY>\r\n\t<FORM ACTION=\"upgrade.php\" METHOD=\"POST\">\r\n\t<H1>PHPBTTracker+ Upgrade</H1>\r\n";

		if (isset($_POST["upgrade_from_query"])) {
			switch ($_POST["upgrade_from_query"]) {
				case PHPBTP16:
					upgr_phpbttrkplus16();
					break;
				default:
					echo "\t<FONT COLOR=RED><B>Upgrade halted; internal script error.</B></FONT>\r\n";
					break;
			}
		} else {
			echo "\t<FONT COLOR=RED><B>Upgrade halted; internal script error.</B></FONT>\r\n";
		}

		echo "\t</FORM>\r\n</BODY>\r\n</HTML>";
		exit;
	}

	if (isset($_POST["step3"])) {
		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<HTML>\r\n<HEAD>\r\n\t<META NAME=\"Author\" CONTENT=\"danomac\">\r\n";
		echo "\t<TITLE>PHPBTTracker+ Upgrade script</TITLE>\r\n</HEAD>\r\n<BODY>\r\n\t<FORM ACTION=\"upgrade.php\" METHOD=\"POST\">\r\n\t<H1>PHPBTTracker+ Upgrade</H1>\r\n";

		if (isset($_POST["old_version"])) {
			switch ($_POST["old_version"]) {
				case NO_SEL:
					echo "\t<FONT COLOR=RED><B>Upgrade halted; no prior version selected.</B></FONT>\r\n";
					break;
				case PHPBTP16:
					pre_upgr_phpbttrkplus16();
					break;
				default:
					echo "\t<FONT COLOR=RED><B>Upgrade halted; no prior version selected.</B></FONT>\r\n";
					break;
			}
		} else {
			echo "\t<FONT COLOR=RED><B>Upgrade halted; no prior version selected.</B></FONT>\r\n";
		}

		echo "\t</FORM>\r\n</BODY>\r\n</HTML>";
		exit;
	}

	if (isset($_POST["step2"])) {
		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<HTML>\r\n<HEAD>\r\n\t<META NAME=\"Author\" CONTENT=\"danomac\">\r\n";
		echo "\t<TITLE>PHPBTTracker+ Upgrade script</TITLE>\r\n</HEAD>\r\n<BODY>\r\n\t<FORM ACTION=\"upgrade.php\" METHOD=\"POST\">\r\n\t<H1>PHPBTTracker+ Upgrade</H1>\r\n";

		if (isset($_POST["understood"]) && strcmp($_POST["understood"], "enabled") == 0) {
			echo "\tThis script <B>does not</B> provide a means to upgrade from the original version of phpbttracker (authored be DeHackEd.)<BR><BR>\r\n";
			echo "\tChoose the version you are upgrading from:&nbsp;&nbsp;\r\n";

			echo "\t<SELECT NAME=\"old_version\">\r\n";

			echo "\t\t<OPTION VALUE=" . NO_SEL . ">Make a selection</OPTION>\r\n";
			echo "\t\t<OPTION VALUE=" . PHPBTP16 . ">PHPBTTracker+ 1.6</OPTION>\r\n";

			echo "\t</SELECT>\r\n";

			echo "\t<BR><BR><INPUT TYPE=\"SUBMIT\" NAME=\"step3\" VALUE=\"Next -&gt;\">\r\n";
		} else {
			echo "\t<FONT COLOR=RED><B>Upgrade halted; please make sure you read the items on the first page and indicate so with the checkbox provided.</B></FONT>\r\n";
		}

		echo "\t</FORM>\r\n</BODY>\r\n</HTML>";
		exit;
	}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
	<META NAME="Author" CONTENT="danomac">
	<TITLE>PHPBTTracker+ Upgrade script</TITLE>
</HEAD>
<BODY>
	<FORM ACTION="upgrade.php" METHOD="POST">
	<H1>PHPBTTracker+ Upgrade</H1>
	There are some <FONT COLOR=RED><U>very important</U></FONT> issues that you need to understand before proceeding.<BR><BR>
	<FONT COLOR=RED>PRE UPGRADE NOTES:</FONT><BR><BR>

	1. There is a PHP bug that affects file uploads to the server. It is not a serious bug, but if you upload something
	that has an apostrophe in the filename (') everything to the left of the apostrophe will be truncated from the filename.<BR><BR>

	2. <B>This script modifies your database!! <FONT COLOR=RED>BACK UP your database and original scripts first!</FONT></B> There is a possibility
	that this script can fail and leave your tracker in an <B>unusable state.</B> If this script fails it will tell you if you might have
	to restore from a backup.<BR><BR>

	<INPUT TYPE=CHECKBOX NAME="understood" VALUE="enabled"> I have read the above and want to continue.
	<BR><BR><INPUT TYPE="SUBMIT" NAME="step2" VALUE="Next -&gt;">
	</FORM>
</BODY>
</HTML>